$!	BUILD.COM
$!	V1.1			30-Sep-1996	IfN/Mey
$!+
$! Compile, link and install SAMBA
$!
$!	P1	- if omitted (or *): Compile/Link only files not found
$!		- file name (no [.vms] and no extension!): compile this file, no link
$!		- ALL: unconditionally build all
$!
$!-
$! Setup
$!
$	on error then goto exit
$	on control_y then goto exit
$	set on
$	save_ver = f$verify(0)
$	status = 1
$	cc_ver = 0
$	cc := CC	! make sure we'll use the real cc command here
$!
$	a = f$parse(f$environment("PROCEDURE"),,,"DIRECTORY") - "]" + ".-]"
$	src = f$parse(f$environment("PROCEDURE"),,,"DEVICE") + -
		f$parse(a,,,"DIRECTORY")
$	set default 'src'
$	if f$type(samba_setup_done) .eqs. "" then @[.vms]setup
$	OBJ := OBJ_'__arch'
$	OLB := OLB_'__arch'
$!
$! analyse command line
$!
$	n = 0
$	par = ""
$	quals = ""
$	cmd = P1 + " " + P2 + " " + P3 + " " + P4 + " " + P5 + " " + P6 + " " +  P7 + " " + P8
$	cmd = f$edit(cmd,"TRIM,COMPRESS,UNCOMMENT")
$ parloop:
$	p = f$edit(f$element(n," ",cmd),"TRIM")
$	n = n + 1
$	if p .eqs. "" then goto parfin
$	q = f$extract(f$locate("/",p),255,p)
$	if q .nes. "/" .and. q .nes. "" then quals = quals + f$edit(q,"TRIM")
$	p = f$element(0,"/",p)
$	if p .nes. "" then par = par + f$edit(p,"TRIM")
$	goto parloop
$ parfin:
$!
$!$sho symb par
$!$sho symb quals
$!$EXIT
$	P1 = f$edit(par,"UPCASE")
$	CFLAGS = __CFLAGS + quals
$	DEFINES = ""
$	if P1 .eqs. "*" then P1 = ""
$	all = P1 .eqs. "ALL"
$	check = P1 .eqs. ""
$!
$! Compile
$! Read MMS description file and find out what we have to do.
$!
$	if all .or. f$search("samba.''olb'") .eqs. "" then library/create samba.'olb'
$	if f$trnlnm("chan") .nes. "" then close chan
$	open/read chan [.vms]descrip.mms
$	prev_a = ""
$	cont = 0
$ rdloop:
$	libflags = ""
$	read/end=rdfin/error=rdfin chan line
$	if cont
$	then				! if this is a continuation line
$		b = f$edit(line,"UPCASE,COMPRESS,TRIM")
$		a = prev_a
$		a2 = f$edit(a,"TRIM,UPCASE,COMPRESS")
$	else
$		a = f$element(0,"=",line)
$		a1 = f$edit(f$extract(0,1,a),"TRIM,COMPRESS")	! 1st char
$		a2 = f$edit(a,"TRIM,UPCASE,COMPRESS")
$		if a1 .eqs. "" then goto rdloop		! skip blank lines
$		if a1 .eqs. "#" then goto rdloop	! skip comments
$		b = f$edit(f$element(1,"=",line),"UPCASE,COMPRESS,TRIM")
$	endif
$	if b .eqs. "="
$	then	! if line does *not* contain an equal sign!
$		a2 = f$edit(f$element(0,":",line),"UPCASE,COMPRESS,TRIM")
$		if f$locate(".$(EXE)",a2) .eq. f$length(a2) then goto rdloop
$		b = f$edit(f$element(1,":",line),"UPCASE,COMPRESS,TRIM")
$		libflags = "/noglobal"
$	endif
$!$ sho symb b
$	if f$locate(".$(O)",b) .eq. f$length(b) then goto rdloop
$	prev_a = a2
$	cont = 0
$	n = 0
$ lineloop:
$	c = f$edit(f$element(n," ",b),"TRIM")
$	if c .eqs. "\"
$	then
$		cont = 1
$		goto rdloop
$	endif
$	if c .eqs. "" then goto linefin
$	n = n + 1
$	if f$locate(".$(O)",c) .eq. f$length(c) then goto lineloop
$	d = f$element(0,".",c)
$	if P1 .nes. "" .and. (.not. all) .and. d .nes. P1 then goto lineloop
$	set noon
$!$ write sys$output "File: ''d', Flags: ''libflags'"
$	call compile 'd' 'libflags'
$	if $status .eq. %X10000002 then goto exit
$	set on
$	libflags = ""
$	goto lineloop
$ linefin:
$	goto rdloop
$ rdfin:
$	if f$trnlnm("chan") .nes. "" then close chan
$!
$	if .not. all .and. P1 .nes. "" then goto exit
$!
$! Link
$!
$	write sys$output ""
$	@[.vms]link all
$!
$! Install
$!
$	read/end=exit/error=exit/prompt="Install now [Y]: " -
	sys$output yn
$	yn = f$edit(yn,"UPCASE,COLLAPSE,UNCOMMENT")
$	if yn .nes. "N" then @[.vms]install
$!
$! finished.
$!
$	goto exit
$!
$!==========================================================================
$ compile:
$	subroutine
$	on error then goto comp_exit
$	on control_y then goto comp_abort
$	set on
$!
$	ccc := CC CONF.H+
$	if check .and. f$search("''P1'.''obj'") .nes. "" then exit
$	if f$search("''P1'.C") .nes. ""
$	then
$		if .not.cc_ver then write sys$output "Compiling ''P1'.C ..."
$		v=f$verify(cc_ver)
$ 'ccc' 'P1'.C/OBJ='P1'.'obj' 'cflags'/DEFINE=(MODULE_NAME='P1''defines')
$!'f$verify(v)'
$	endif
$	if f$search("[.VMS]''P1'.C") .nes. ""
$	then
$		if .not.cc_ver then write sys$output "Compiling [.VMS]''P1'.C ..."
$		v=f$verify(cc_ver)
$ 'ccc' [.VMS]'P1'.C/OBJ='P1'.'obj' 'cflags'/DEFINE=(MODULE_NAME='P1''defines')
$!'f$verify(v)'
$	endif
$	if f$search("[.VMS]''P1'.MAR") .nes. ""
$	then
$		if .not.cc_ver then write sys$output "Compiling [.VMS]''P1'.MAR ..."
$		v=f$verify(cc_ver)
$ MACRO [.VMS]'P1'.MAR/OBJ='P1'.'obj'
$!'f$verify(v)'
$	endif
$!
$	if f$locate("/NOOB",f$edit(CFLAGS,"UPCASE")) .eq. f$length(CFLAGS)
$	then
$		if f$search("''P1'.''obj'") .nes. ""
$		then
$		v=f$verify(cc_ver)
$ LIBRARY/REPLACE SAMBA.'olb' 'P1'.'obj' 'P2'
$!'f$verify(v)'
$		endif
$	endif
$	exit
$!
$ comp_abort:!'f$verify(v)'
$	if f$search("''P1'.''obj'") .nes. "" then delete 'P1'.'obj';*
$	exit %X10000002
$!
$ comp_exit:$!'f$verify(v)'
$	exit 1
$!
$	endsubroutine
$!
$!==========================================================================
$ exit:
$	if f$trnlnm("chan") .nes. "" then close chan
$	exit status + (0 * 'f$verify(save_ver)')
