/*	posixtim.h							*/

/* modified for samba */

#ifndef __POSIXTIM_LOADED

#define ftime		posix_ftime
#define time		posix_time
#define localtime	posix_localtime
#define gmtime		posix_gmtime
#define mktime		posix_mktime
#define ctime		posix_ctime
#define tzset		posix_tzset
#define	gettimeofday	posix_gettimeofday
#define utime		posix_utime
#define stat		posix_stat
#define lstat		posix_stat
#define fstat		posix_fstat

#if 1
#define tzname		posix_tzname
#define daylight	posix_daylight
#define timezone	posix_timezone
#endif
/* #include <time.h> */

/*
 * The following two structures are used only with gettimeofday().
 */
#if 0
#if defined(VMS) && !defined(__SOCKET_LOADED)
struct timeval {
	long tv_sec;
	long tv_usec;
};
#endif
#endif

struct timezone {
	int tz_minuteswest;
	int tz_dsttime;
};

#if 0
#if defined(VMS) && !defined(__UTIME_LOADED)
struct utimbuf {
	time_t	actime;
	time_t	modtime;
};
#endif
#endif
/*
 * Prototypes for functions not supported at all by the C RTL.
 */
void tzset		(void);
/* int gettimeofday	(struct timeval * __tv, struct timezone * __tz); */
/* int utime		(const char * __path, const struct utimbuf * __times); */

/*
 * References to some global variables defined in POSIXTIM.C
 */
extern char *	tzname[2];
extern int	daylight;
extern long	timezone;


#endif		/* __POSIXTIM_LOADED */
