$!	setup.com
$!	V1.4			1-Feb-1997	IfN/Mey
$!+
$! Setup logicals and symbols for building/linking samba.
$!-
$ set noon
$ on control_y then goto exit
$ on error then goto exit
$!
$ delete := delete
$ rename := rename
$!
$ df := define/nolog
$ a = f$parse(f$environment("PROCEDURE"),,,"DIRECTORY") - "]" + ".-]"
$ me = f$parse(f$environment("PROCEDURE"),,,"DEVICE") + -
       f$parse(a,,,"DIRECTORY")
$ set default 'me'
$ root = me - "]"
$!
$ dist_version = P1
$!
$ __samba_version == "1.9.16"
$ __arch == f$getsyi("ARCH_NAME")
$ __alpha == f$getsyi("ARCH_NAME") .eqs. "Alpha"
$ __decc == f$search(f$parse("DECC$COMPILER","SYS$SYSTEM:.EXE")) .nes. ""
$ __ucx == f$getdvi("UCX$DEVICE","EXISTS") .eqs. "TRUE"
$!$ __socketshr == f$search("SOCKETSHR") .nes. ""
$ __socketshr == 0	! We currently don't support SOCKETSHR
$ __isMultiNet = f$trnlnm("MULTINET_KERNEL_BASE_ADDRESS") .nes. ""
$ __isTCPware = f$trnlnm("TCPWARE_NETCP_MBX") .nes. ""
$!
$ if .not. __decc
$ then
$	type sys$input

	The only currently supported compiler is DEC-C V5.0 and higher.

$	goto exit
$ endif
$!
$ write sys$output -
"VMS support for Samba 1.9.16p11 - use with other versions may not work."
$!
$! Definitions used by MMS/MMK:
$!
$ if __alpha then __alpha__ == 1
$ if __decc then __decc__ == 1
$ if __ucx then __ucx__ == 1
$ if __socketshr then __socketshr__ == 1
$!
$ __ucx_emu = ""
$ if __isMultiNet then ucx_emu = "MULTINET"
$ if __isTCPware then ucx_emu = "TCPWARE"
$
$! Configure header files.
$! Must be done before defining the CC command, since results
$! are used to define it.
$!
$ cc:=CC	! be sure cc is not defined locally
$ write sys$output "Configure..."
$ call configure "dirent.h|.le.70000000,sys/ioctl.h,sys/wait.h,if.h,if_arp.h"
$ delete/symbol cc	! delete local definition
$!
$ if (.not.__ucx) .and. (.not.__socketshr)
$ then
$	type sys$input

	You must have either SOCKETSHR or native UCX installed.
	Using other packages directly is not supported.

	However, SOCKETSHR supports all TCP/IP packages (e.g. UCX, Multinet,
	TCPware, Pathway, CMU/IP)

$	goto exit
$ endif
$ if __SOCKETSHR
$ then
$	write sys$output "SOCKETSHR is used as TCP/IP interface."
$ else
$	if __ucx_emu .eqs. ""
$	then
$		write sys$output "Native UCX is used as TCP/IP interface."
$	else
$		write sys$output "''__ucx_emu' UCX emulation is used as TCP/IP interface."
$	endif
$ endif
$!
$ if f$type(mmk) .eqs. ""
$ then
$	mmk = "MMS"
$ endif
$ mms:=='mmk'/descrip=[.vms]
$ mmsd:=='mmk'/descrip=[.vms]/macro=( -
	ldebug="""/debug""", -
	cdebug="""/list=.lis_alpha/show=all""")
$
$ vaxc_include = "''root'.vms.vaxc]"
$ decc_include = "''root'.vms.decc]"
$!
$ if .not.__decc
$ then
$	define/nolog VAXCRTL 'f$parse("VAXCRTL","SYS$SHARE:.EXE")'
$ endif
$!
$ call defincl SYS
$ call defincl NETINET
$ call defincl ARPA
$!
$! Define CC command
$!
$ cc_decc = ""
$ if __decc
$ then
$!$	incl = ",[.vms.decc]"
$	incl = ""
$ else
$	incl = ",[.vms.vaxc]"
$ endif
$!
$ save_ver = f$verify(0)
$!$ set verify
$ if f$trnlnm("CHAN") .nes. "" then close chan
$ open/write chan 'root']conf.h
$ write chan "#pragma module MODULE_NAME" ! MODULE_NAME is defined by BUILD.COM
$ write chan "#define _VMS_V6_SOURCE"	! don't use VMS V7 features for now
$ write chan "#define _DECC_V4_SOURCE"	! we want (must) support older compilers -sigh!
$ if dist_version .nes. ""
$ then
$    write chan "#undef __VMS_VER"
$    write chan "#define __VMS_VER  ''dist_version'" ! lie about VMS version
$    write chan "#define __VMS_VER2 ''dist_version'" ! remember actual version
$ else
$    write chan "#define __VMS_VER2 ''__VMS_VER'" ! remember actual version
$ endif
$ write chan "#define _stat vms_stat"	! see [.VMS]POSIXTIM.C
$ write chan "#define _fstat vms_fstat"
$ write chan "#define SMBLOGFILE ""/samba_root/var/log.smb"""
$ write chan "#define NMBLOGFILE ""/samba_root/var/log.nmb"""
$ write chan "#define CONFIGFILE ""/samba_root/lib/smb.conf"""
$ write chan "#define LMHOSTSFILE ""/samba_root/lib/lmhosts"""
$ write chan "#define LOCKDIR ""/samba_root/var/locks"""
$ write chan "#define SMBRUN ""smbrun"""
$ write chan "#define WORKGROUP ""LANGROUP"""
$ write chan "#define GUEST_ACCOUNT ""UCX$NOBODY"""
$!$ write chan "#define DEBUG_PASSWORD 1" ! display password with debug output
$ if __socketshr
$ then
$   write chan "#define SOCKETSHR 1"
$   write chan "#define _read si_read"
$   write chan "#define _close si_close"
$ endif
$ if f$trnlnm("CHAN") .nes. "" then close chan
$!
$! Two short commands
$!
$ bld :== @'root'.vms]build """"
$ bldlis :== @'root'.vms]build """"/LIST=.LIS_ALPHA/SHOW=ALL/NOOBJ
$ lnk :== @'root'.vms]link
$!
$! Setup __CFLAGS
$!
$ __CFLAGS :== -
/include=([]'incl',[.vms]) -
/warning=disable=(MISSINGRETURN)
$ if __decc
$ then
$ cc_decc := -
/nested=primary -
/prefix=all
$ endif
$!'f$verify(save_ver)'
$ __CFLAGS == __CFLAGS + cc_decc
$!
$! Create .OLB
$!
$ if f$search("samba.olb_''__arch'") .eqs. "" then library/create samba.olb_'__arch'
$!
$ if dist_version .nes. "" then __VMS_VER == dist_version
$ samba_setup_done == 1
$!
$! **** EXIT ****
$!
$exit:
$ exit
$!
$! **** Subroutines ****
$!
$ defincl:
$ subroutine
$ if __decc
$ then
$!$	df 'P1' 'decc_include','root'.vms]
$	df 'P1' 'root'.vms]
$ else
$	df 'P1' 'vaxc_include','root'.vms]
$ endif
$ endsubroutine
$!
$!
$ configure:
$!
$!	P1 - list of header files tested
$!
$ subroutine
$	tstfile := _check.c
$	lstfile := _check.lis
$	errfile := _check.err
$	if f$trnlnm("CHAN") .nes. "" then close chan
$	if f$search(tstfile) .nes. "" then delete/noconf 'tstfile'.*
$	if f$search(lstfile) .nes. "" then delete/noconf 'lstfile'.*
$	if f$search(errfile) .nes. "" then delete/noconf 'errfile'.*
$!
$! Part I - get some variables
$!
$	open/write chan 'tstfile'
$	write chan "/*_BEGIN*/"
$	write chan "/*_VAR __VMS_VER */ __VMS_VER ;"
$	write chan "/*_VAR __DECC_VER */ __DECC_VER ;"
$	write chan "/*_END_VAR*/"
$	if f$trnlnm("CHAN") .nes. "" then close chan
$	define/user sys$output nla0:
$	define/user sys$error nla0:
$	set noon
$	cc 'tstfile' -
		/show=expansion/noobject -
		/preprocessor_only='lstfile'/comment
$	var = ""
$	__vms_ver = "10000000"
$	__decc_ver = "10000000"
$	open/read chan 'lstfile'
$ rdloop2:
$	read/end=rdfin2/error=rdfin2 chan line
$	line2 = f$edit(line,"TRIM,COMPRESS")
$	if f$locate("/*_END_VAR*/",line2) .ne. f$length(line2) then goto rdfin2
$!
$	if f$locate("/*_VAR",line2) .ne. f$length(line2)
$	then
$		var = f$edit(f$element(1," ",line2),"TRIM")
$		'var' = f$edit(f$element(3," ",line2),"TRIM")
$	endif
$	goto rdloop2
$ rdfin2:
$	if f$trnlnm("CHAN") .nes. "" then close chan
$	__VMS_VER == __vms_ver		! set global symbols
$	__DECC_VER == __decc_ver
$!
$! Part II - check for specified header files.
$!
$	open/write chan 'tstfile'
$	if dist_version .nes. ""
$	then
$		write chan "#undef __VMS_VER"
$		write chan "#define __VMS_VER ''dist_version'"
$		__vms_ver = dist_version ! set local symbol - used in sub only
$	endif
$	write chan "/*_BEGIN*/"
$	n = 0
$ wrloop:
$	a = f$edit(f$element(n,",",P1),"TRIM")
$	if a .eqs. "," then goto wrfin
$	hfile2 = f$edit(f$element(0,"|",a),"TRIM")
$	hfile = hfile2
$	if f$search("''root'.vms]''hfile'") .nes. ""
$	then						! switch to "unused"
$		if f$search("''root'.vms]_''hfile'") .nes. ""
$		then
$			delete 'root'.vms]'hfile';*
$		else
$			rename 'root'.vms]'hfile' 'root'.vms]_'hfile'
$		endif
$	endif
$	if f$locate("/",hfile2) .ne. f$length(hfile2) then -
		hfile = f$edit(f$element(1,"/",hfile2),"TRIM")
$	cond_vms_ver = f$element(1,"|",a)
$	if cond_vms_ver .eqs. "|" then cond_vms_ver = ".eq.00000000"
$	cond_decc_ver = f$element(2,"|",a)
$	if cond_decc_ver .eqs. "|" then cond_decc_ver = ".eq.00000000"
$	n = n + 1
$	if f$search("''root'.vms]_''hfile'") .nes. ""
$	then			! the alternative file is at least present
$		if (__VMS_VER 'cond_vms_ver') .or. -
		   (__DECC_VER 'cond_decc_ver')
$		then		! unconditional use
$			rename 'root'.vms]_'hfile' 'root'.vms]'hfile'
$		else		! check out
$			write chan "#include <''hfile2'>"
$		endif
$	endif
$	goto wrloop
$ wrfin:
$	write chan "/*_END*/"
$	if f$trnlnm("CHAN") .nes. "" then close chan
$	define/user sys$output 'errfile'
$	define/user sys$error nla0:
$	set noon
$	cc 'tstfile' -
		/show=expansion/noobject -
		/preprocessor_only=NLA0:/comment
$!
$	if f$search(errfile) .eqs. "" then goto rdfin1x
$	open/read chan 'errfile'
$	hfile = ""
$ rdloop1:
$	read/end=rdfin1/error=rdfin1 chan line
$	line2 = f$edit(line,"TRIM,COMPRESS")
$	if f$locate("/*_END*/",line2) .ne. f$length(line2) then goto rdfin1
$	if f$element(0," ",line2) .eqs. "#include"
$	then
$		hfile2 = f$element(1," ",line2) - ">" - "<"
$		hfile = hfile2
$		if f$locate("/",hfile2) .ne. f$length(hfile2) then -
			hfile = f$edit(f$element(1,"/",hfile2),"TRIM")
$		cond_vms_ver = f$element(3," ",line2)
$		cond_decc_ver = f$element(4," ",line2)
$	endif
$	if f$locate("NOINCLFILE",line2) .ne. f$length(line2)
$	then
$		if f$search("''root'.vms]_''hfile'") .nes. "" then -
			rename 'root'.vms]_'hfile' 'root'.vms]'hfile'
$	endif
$	goto rdloop1
$ rdfin1:
$	close chan
$ rdfin1x:
$!
$	if f$search(tstfile) .nes. "" then delete/noconf 'tstfile'.*
$	if f$search(lstfile) .nes. "" then delete/noconf 'lstfile'.*
$	if f$search(errfile) .nes. "" then delete/noconf 'errfile'.*
$ endsubroutine
